image: openjdk:8-jdk

before_script:
  - df -h; free -h
  - apt-get --quiet update --yes
  - apt-get --quiet install --yes wget unzip lib32stdc++6 lib32z1
  - wget --quiet --output-document=android-sdk-tools-linux.zip https://dl.google.com/android/repository/sdk-tools-linux-4333796.zip
  - unzip -qq android-sdk-tools-linux.zip -d android-sdk
  - echo y | android-sdk/tools/bin/sdkmanager --update >/dev/null
  - echo y | android-sdk/tools/bin/sdkmanager --install platform-tools >/dev/null
  - export ANDROID_HOME=$PWD/android-sdk
  - export PATH=$PATH:$PWD/android-sdk/platform-tools/
  - apt-get --quiet install --yes python2.7
  - mkdir -p ~/bin
  - curl https://storage.googleapis.com/git-repo-downloads/repo > ~/bin/repo
  - chmod a+x ~/bin/repo
  - export PATH=$PATH:$HOME/bin

stages:
  - build

lineage-15.1:
  stage: build
  retry: 2
  tags:
    - open-droid
  script:
    - apt-get --quiet install --yes bc bison build-essential ccache curl flex g++-multilib gcc-multilib git gnupg gperf imagemagick lib32ncurses5-dev lib32readline-dev lib32z1-dev liblz4-tool libncurses5-dev libsdl1.2-dev libssl-dev libwxgtk3.0-dev libxml2 libxml2-utils lzop pngcrush rsync schedtool squashfs-tools xsltproc zip zlib1g-dev > /dev/null
    - mkdir -p ~/android/lineage-15.1
    - cd ~/android/lineage-15.1
    - repo init --depth=1 -u https://github.com/LineageOS/android.git -b lineage-15.1 > /dev/null
    - mkdir -p ~/android/lineage-15.1/.repo/local_manifests
    - cp $CI_PROJECT_DIR/lineage-15.1/$BUILDSCRIPT_DEVICENAME.xml ~/android/lineage-15.1/.repo/local_manifests/
    - repo sync --force-sync -c --no-clone-bundle --no-tags -j12 > /dev/null
    - $CI_PROJECT_DIR/lineage-15.1/build.sh

  artifacts:
    paths:
    - $OUT
    
lineage-16:
  stage: build
  retry: 2
  tags:
    - open-droid
  script:
    - apt-get --quiet install --yes bc bison build-essential ccache curl flex g++-multilib gcc-multilib git gnupg gperf imagemagick lib32ncurses5-dev lib32readline-dev lib32z1-dev liblz4-tool libncurses5-dev libsdl1.2-dev libssl-dev libwxgtk3.0-dev libxml2 libxml2-utils lzop pngcrush rsync schedtool squashfs-tools xsltproc zip zlib1g-dev > /dev/null
    - mkdir -p ~/android/lineage-16
    - cd ~/android/lineage-16
    - repo init --depth=1 -u https://github.com/LineageOS/android.git -b lineage-16 > /dev/null
    - mkdir -p ~/android/lineage-16/.repo/local_manifests
    - cp $CI_PROJECT_DIR/lineage-16/$BUILDSCRIPT_DEVICENAME.xml ~/android/lineage-16/.repo/local_manifests/
    - repo sync --force-sync -c --no-clone-bundle --no-tags -j12 > /dev/null
    - $CI_PROJECT_DIR/lineage-16/build.sh

  artifacts:
    paths:
    - $OUT

pixelexp-oreo-mr1:
  stage: build
  retry: 2
  tags:
    - open-droid
  script:
    - apt-get --quiet install --yes build-essential bison g++-multilib git gperf libxml2-utils make zlib1g-dev zip liblz4-tool libncurses5 > /dev/null
    - mkdir -p ~/android/pixel-oreo-mr1
    - cd ~/android/pixel-oreo-mr1
    - repo init --depth=1 -u https://github.com/PixelExperience/manifest -b oreo-mr1 > /dev/null
    - mkdir -p ~/android/pixel-oreo-mr1/.repo/local_manifests
    - cp $CI_PROJECT_DIR/lineage-15.1/$BUILDSCRIPT_DEVICENAME.xml ~/android/pixel-oreo-mr1/.repo/local_manifests/
    - repo sync --force-sync -c --no-clone-bundle --no-tags -j12 > /dev/null
    - source build/envsetup.sh
    - source build/envsetup.sh
    - lunch aosp_$BUILDSCRIPT_DEVICENAME-userdebug
    - mka bacon -j$(nproc --all)

  artifacts:
    paths:
    - $OUT
